proc write {address value} {
	set address [string range $address 2 [expr {[string length $address]-1}]]
	create_hw_axi_txn -quiet -force wr_tx [get_hw_axis hw_axi_1] -address $address -data $value -len 1 -size 32 -type write
	run_hw_axi -quiet wr_tx
}

proc read {address} {
	set address [string range $address 2 [expr {[string length $address]-1}]]
	create_hw_axi_txn -quiet -force rd_tx [get_hw_axis hw_axi_1] -address $address -len 1 -size 32 -type read
	run_hw_axi -quiet rd_tx
	return 0x[get_property DATA [get_hw_axi_txn rd_tx]]
}

proc offset_reg {base offset} {
	set base [string range $base 2 [expr {[string length $base]-1}]]
	set offset [string range $offset 2 [expr {[string length $offset]-1}]]
	return 0x[format %x [expr {[expr 0x$base]+[expr 0x$offset]}]]
}

proc test_gpio {gpio} {
	while {1} {
		write $gpio 0x00000001
		after 1000
		write $gpio 0x00000000
	}
}

proc string2hex s {
    binary scan [encoding convertto utf-8 $s] H* hex
    regsub -all (..) $hex {\1 }
}

proc print {uart string} {
	set address [string range $uart 2 [expr {[string length $uart]-1}]]
	set hex_string [split [string trim [string2hex $string]] " "]
	foreach char $hex_string {
		write $uart 000000$char
		after 100
	}
}